#include "bintest.h"

int main(int argc, char ** argv) {
  unsigned char * buf;
  ETERM * decoded;
  FILE * file;
  int n;

  erl_init(NULL, 0);

  printf("Reading binary file off disk\n");
  
  file = fopen("badbinary","r+b");
  
  /* For simplicity, hard coding the size of the binary as 124484 (verified as correct) */
  
  buf = malloc(SIZE_OF_BAD_BINARY);
  
  n = fread(buf, SIZE_OF_BAD_BINARY, 1, file);
  
  if(n != 1) {
    printf("Error reading binary from file!\n");
    exit(0);
  }
  
  printf("Successfully read binary off disk, attempting to decode into ETERM\n");
  
  decoded = (ETERM *)erl_decode(buf);
  
  if(decoded == NULL) {
    printf("Error decoding binary to ETERM\n");
    exit(0);
  }
  
  printf("Success decoding!\n");
  
  return 1;
}

